<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
"mybatis-3-mapper.dtd">
<mapper namespace="com.mortals.xhx.module.metting.dao.ibatis.MettingRecordDaoImpl">

    <!-- 字段和属性映射 -->
    <resultMap type="MettingRecordEntity" id="MettingRecordEntity-Map">
            <id  property="id" column="id" />
            <result property="meetName" column="meetName" />
            <result property="meetDate" column="meetDate" />
            <result property="meetTimeStart" column="meetTimeStart" />
            <result property="meetTimeEnd" column="meetTimeEnd" />
            <result property="roomId" column="roomId" />
            <result property="roomName" column="roomName" />
            <result property="meetDeptName" column="meetDeptName" />
            <result property="meetStatus" column="meetStatus" />
            <result property="finishMethod" column="finishMethod" />
            <result property="remark" column="remark" />
            <result property="createUserId" column="createUserId" />
            <result property="createTime" column="createTime" />
            <result property="updateUserId" column="updateUserId" />
            <result property="updateTime" column="updateTime" />
            
    </resultMap>


    <!-- 表所有列 -->
    <sql id="_columns">
        <trim suffixOverrides="," suffix="">
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('id') or colPickMode == 1 and data.containsKey('id')))">
                    a.id,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('meetName') or colPickMode == 1 and data.containsKey('meetName')))">
                    a.meetName,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('meetDate') or colPickMode == 1 and data.containsKey('meetDate')))">
                    a.meetDate,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('meetTimeStart') or colPickMode == 1 and data.containsKey('meetTimeStart')))">
                    a.meetTimeStart,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('meetTimeEnd') or colPickMode == 1 and data.containsKey('meetTimeEnd')))">
                    a.meetTimeEnd,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('roomId') or colPickMode == 1 and data.containsKey('roomId')))">
                    a.roomId,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('roomName') or colPickMode == 1 and data.containsKey('roomName')))">
                    a.roomName,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('meetDeptName') or colPickMode == 1 and data.containsKey('meetDeptName')))">
                    a.meetDeptName,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('meetStatus') or colPickMode == 1 and data.containsKey('meetStatus')))">
                    a.meetStatus,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('finishMethod') or colPickMode == 1 and data.containsKey('finishMethod')))">
                    a.finishMethod,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('remark') or colPickMode == 1 and data.containsKey('remark')))">
                    a.remark,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('createUserId') or colPickMode == 1 and data.containsKey('createUserId')))">
                    a.createUserId,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('createTime') or colPickMode == 1 and data.containsKey('createTime')))">
                    a.createTime,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('updateUserId') or colPickMode == 1 and data.containsKey('updateUserId')))">
                    a.updateUserId,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('updateTime') or colPickMode == 1 and data.containsKey('updateTime')))">
                    a.updateTime,
                </if>
        </trim>
    </sql>
    <!-- 新增 区分主键自增加还是业务插入 -->
    <insert id="insert" parameterType="MettingRecordEntity"  useGeneratedKeys="true" keyProperty="id">
        insert into mortals_xhx_metting_record
        (meetName,meetDate,meetTimeStart,meetTimeEnd,roomId,roomName,meetDeptName,meetStatus,finishMethod,remark,createUserId,createTime,updateUserId,updateTime)
        VALUES
        (#{meetName},#{meetDate},#{meetTimeStart},#{meetTimeEnd},#{roomId},#{roomName},#{meetDeptName},#{meetStatus},#{finishMethod},#{remark},#{createUserId},#{createTime},#{updateUserId},#{updateTime})
    </insert>

    <!-- 批量新增 -->
    <insert id="insertBatch" parameterType="paramDto">
        insert into mortals_xhx_metting_record
        (meetName,meetDate,meetTimeStart,meetTimeEnd,roomId,roomName,meetDeptName,meetStatus,finishMethod,remark,createUserId,createTime,updateUserId,updateTime)
        VALUES
        <foreach collection="data.dataList" item="item" index="index" separator="," >
            (#{item.meetName},#{item.meetDate},#{item.meetTimeStart},#{item.meetTimeEnd},#{item.roomId},#{item.roomName},#{item.meetDeptName},#{item.meetStatus},#{item.finishMethod},#{item.remark},#{item.createUserId},#{item.createTime},#{item.updateUserId},#{item.updateTime})
        </foreach>
    </insert>


    <!-- 根据ParamDto更新 -->
    <update id="update" parameterType="paramDto">
        update mortals_xhx_metting_record as a
        set
        <trim suffixOverrides="," suffix="">
            <if test="(colPickMode==0 and data.containsKey('meetName')) or (colPickMode==1 and !data.containsKey('meetName'))">
                a.meetName=#{data.meetName},
            </if>
            <if test="(colPickMode==0 and data.containsKey('meetDate')) or (colPickMode==1 and !data.containsKey('meetDate'))">
                a.meetDate=#{data.meetDate},
            </if>
            <if test="(colPickMode==0 and data.containsKey('meetTimeStart')) or (colPickMode==1 and !data.containsKey('meetTimeStart'))">
                a.meetTimeStart=#{data.meetTimeStart},
            </if>
            <if test="(colPickMode==0 and data.containsKey('meetTimeEnd')) or (colPickMode==1 and !data.containsKey('meetTimeEnd'))">
                a.meetTimeEnd=#{data.meetTimeEnd},
            </if>
            <if test="(colPickMode==0 and data.containsKey('roomId')) or (colPickMode==1 and !data.containsKey('roomId'))">
                a.roomId=#{data.roomId},
            </if>
            <if test="(colPickMode==0 and data.containsKey('roomIdIncrement')) or (colPickMode==1 and !data.containsKey('roomIdIncrement'))">
                a.roomId=ifnull(a.roomId,0) + #{data.roomIdIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('roomName')) or (colPickMode==1 and !data.containsKey('roomName'))">
                a.roomName=#{data.roomName},
            </if>
            <if test="(colPickMode==0 and data.containsKey('meetDeptName')) or (colPickMode==1 and !data.containsKey('meetDeptName'))">
                a.meetDeptName=#{data.meetDeptName},
            </if>
            <if test="(colPickMode==0 and data.containsKey('meetStatus')) or (colPickMode==1 and !data.containsKey('meetStatus'))">
                a.meetStatus=#{data.meetStatus},
            </if>
            <if test="(colPickMode==0 and data.containsKey('meetStatusIncrement')) or (colPickMode==1 and !data.containsKey('meetStatusIncrement'))">
                a.meetStatus=ifnull(a.meetStatus,0) + #{data.meetStatusIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('finishMethod')) or (colPickMode==1 and !data.containsKey('finishMethod'))">
                a.finishMethod=#{data.finishMethod},
            </if>
            <if test="(colPickMode==0 and data.containsKey('finishMethodIncrement')) or (colPickMode==1 and !data.containsKey('finishMethodIncrement'))">
                a.finishMethod=ifnull(a.finishMethod,0) + #{data.finishMethodIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('remark')) or (colPickMode==1 and !data.containsKey('remark'))">
                a.remark=#{data.remark},
            </if>
            <if test="(colPickMode==0 and data.containsKey('createUserId')) or (colPickMode==1 and !data.containsKey('createUserId'))">
                a.createUserId=#{data.createUserId},
            </if>
            <if test="(colPickMode==0 and data.containsKey('createUserIdIncrement')) or (colPickMode==1 and !data.containsKey('createUserIdIncrement'))">
                a.createUserId=ifnull(a.createUserId,0) + #{data.createUserIdIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('createTime')) or (colPickMode==1 and !data.containsKey('createTime'))">
                a.createTime=#{data.createTime},
            </if>
            <if test="(colPickMode==0 and data.containsKey('updateUserId')) or (colPickMode==1 and !data.containsKey('updateUserId'))">
                a.updateUserId=#{data.updateUserId},
            </if>
            <if test="(colPickMode==0 and data.containsKey('updateUserIdIncrement')) or (colPickMode==1 and !data.containsKey('updateUserIdIncrement'))">
                a.updateUserId=ifnull(a.updateUserId,0) + #{data.updateUserIdIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('updateTime')) or (colPickMode==1 and !data.containsKey('updateTime'))">
                a.updateTime=#{data.updateTime},
            </if>
        </trim>
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
    </update>
    <!-- 批量更新 -->
    <update id="updateBatch" parameterType="paramDto">
        update mortals_xhx_metting_record as a
        <trim prefix="set" suffixOverrides=",">
                <trim prefix="meetName=(case" suffix="ELSE meetName end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('meetName')) or (colPickMode==1 and !item.containsKey('meetName'))">
                            when a.id=#{item.id} then #{item.meetName}
                        </if>
                    </foreach>
                </trim>
                <trim prefix="meetDate=(case" suffix="ELSE meetDate end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('meetDate')) or (colPickMode==1 and !item.containsKey('meetDate'))">
                            when a.id=#{item.id} then #{item.meetDate}
                        </if>
                    </foreach>
                </trim>
                <trim prefix="meetTimeStart=(case" suffix="ELSE meetTimeStart end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('meetTimeStart')) or (colPickMode==1 and !item.containsKey('meetTimeStart'))">
                            when a.id=#{item.id} then #{item.meetTimeStart}
                        </if>
                    </foreach>
                </trim>
                <trim prefix="meetTimeEnd=(case" suffix="ELSE meetTimeEnd end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('meetTimeEnd')) or (colPickMode==1 and !item.containsKey('meetTimeEnd'))">
                            when a.id=#{item.id} then #{item.meetTimeEnd}
                        </if>
                    </foreach>
                </trim>
                        <trim prefix="roomId=(case" suffix="ELSE roomId end),">
                            <foreach collection="data.dataList" item="item" index="index" separator="" >
                                <choose>
                                    <when test="(colPickMode==0 and item.containsKey('roomId')) or (colPickMode==1 and !item.containsKey('roomId'))">
                                        when a.id=#{item.id} then #{item.roomId}
                                    </when>
                                    <when test="(colPickMode==0 and item.containsKey('roomIdIncrement')) or (colPickMode==1 and !item.containsKey('roomIdIncrement'))">
                                        when a.id=#{item.id} then ifnull(a.roomId,0) + #{item.roomIdIncrement}
                                    </when>
                                </choose>
                            </foreach>
                        </trim>
                <trim prefix="roomName=(case" suffix="ELSE roomName end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('roomName')) or (colPickMode==1 and !item.containsKey('roomName'))">
                            when a.id=#{item.id} then #{item.roomName}
                        </if>
                    </foreach>
                </trim>
                <trim prefix="meetDeptName=(case" suffix="ELSE meetDeptName end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('meetDeptName')) or (colPickMode==1 and !item.containsKey('meetDeptName'))">
                            when a.id=#{item.id} then #{item.meetDeptName}
                        </if>
                    </foreach>
                </trim>
                        <trim prefix="meetStatus=(case" suffix="ELSE meetStatus end),">
                            <foreach collection="data.dataList" item="item" index="index" separator="" >
                                <choose>
                                    <when test="(colPickMode==0 and item.containsKey('meetStatus')) or (colPickMode==1 and !item.containsKey('meetStatus'))">
                                        when a.id=#{item.id} then #{item.meetStatus}
                                    </when>
                                    <when test="(colPickMode==0 and item.containsKey('meetStatusIncrement')) or (colPickMode==1 and !item.containsKey('meetStatusIncrement'))">
                                        when a.id=#{item.id} then ifnull(a.meetStatus,0) + #{item.meetStatusIncrement}
                                    </when>
                                </choose>
                            </foreach>
                        </trim>
                        <trim prefix="finishMethod=(case" suffix="ELSE finishMethod end),">
                            <foreach collection="data.dataList" item="item" index="index" separator="" >
                                <choose>
                                    <when test="(colPickMode==0 and item.containsKey('finishMethod')) or (colPickMode==1 and !item.containsKey('finishMethod'))">
                                        when a.id=#{item.id} then #{item.finishMethod}
                                    </when>
                                    <when test="(colPickMode==0 and item.containsKey('finishMethodIncrement')) or (colPickMode==1 and !item.containsKey('finishMethodIncrement'))">
                                        when a.id=#{item.id} then ifnull(a.finishMethod,0) + #{item.finishMethodIncrement}
                                    </when>
                                </choose>
                            </foreach>
                        </trim>
                <trim prefix="remark=(case" suffix="ELSE remark end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('remark')) or (colPickMode==1 and !item.containsKey('remark'))">
                            when a.id=#{item.id} then #{item.remark}
                        </if>
                    </foreach>
                </trim>
                        <trim prefix="createUserId=(case" suffix="ELSE createUserId end),">
                            <foreach collection="data.dataList" item="item" index="index" separator="" >
                                <choose>
                                    <when test="(colPickMode==0 and item.containsKey('createUserId')) or (colPickMode==1 and !item.containsKey('createUserId'))">
                                        when a.id=#{item.id} then #{item.createUserId}
                                    </when>
                                    <when test="(colPickMode==0 and item.containsKey('createUserIdIncrement')) or (colPickMode==1 and !item.containsKey('createUserIdIncrement'))">
                                        when a.id=#{item.id} then ifnull(a.createUserId,0) + #{item.createUserIdIncrement}
                                    </when>
                                </choose>
                            </foreach>
                        </trim>
                <trim prefix="createTime=(case" suffix="ELSE createTime end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('createTime')) or (colPickMode==1 and !item.containsKey('createTime'))">
                            when a.id=#{item.id} then #{item.createTime}
                        </if>
                    </foreach>
                </trim>
                        <trim prefix="updateUserId=(case" suffix="ELSE updateUserId end),">
                            <foreach collection="data.dataList" item="item" index="index" separator="" >
                                <choose>
                                    <when test="(colPickMode==0 and item.containsKey('updateUserId')) or (colPickMode==1 and !item.containsKey('updateUserId'))">
                                        when a.id=#{item.id} then #{item.updateUserId}
                                    </when>
                                    <when test="(colPickMode==0 and item.containsKey('updateUserIdIncrement')) or (colPickMode==1 and !item.containsKey('updateUserIdIncrement'))">
                                        when a.id=#{item.id} then ifnull(a.updateUserId,0) + #{item.updateUserIdIncrement}
                                    </when>
                                </choose>
                            </foreach>
                        </trim>
                <trim prefix="updateTime=(case" suffix="ELSE updateTime end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('updateTime')) or (colPickMode==1 and !item.containsKey('updateTime'))">
                            when a.id=#{item.id} then #{item.updateTime}
                        </if>
                    </foreach>
                </trim>
        </trim>
        where id in
        <foreach collection="data.dataList" item="item" index="index" open="(" separator="," close=")">
            #{item.id}
        </foreach>
    </update>
    <!-- 根据主健查询 -->
    <select id="getByKey" parameterType="paramDto" resultMap="MettingRecordEntity-Map">
        select <include refid="_columns"/>
        from mortals_xhx_metting_record as a
        where a.id=#{condition.id}
    </select>
    <!-- 根据主健删除 -->
    <delete id="deleteByKey" parameterType="paramDto">
        delete a.* from mortals_xhx_metting_record as a where a.id=#{condition.id}
    </delete>
    <!-- 根据主健删除一批，针对单一主健有效 -->
    <delete id="deleteByKeys">
        delete from mortals_xhx_metting_record where id in
        <foreach collection="array" item="item" index="index" open="(" separator="," close=")">
            #{item}
        </foreach>
    </delete>
    <!-- 根据主健列表删除一批，针对单一主健有效 -->
    <delete id="deleteByKeyList">
        delete from mortals_xhx_metting_record where id in
        <foreach collection="list" item="item" index="index" open="(" separator="," close=")">
            #{item}
        </foreach>
    </delete>

    <!-- 根据对象列表删除一批，针对单一主健有效 -->
    <delete id="deleteByEntityList">
        delete from mortals_xhx_metting_record where id in
        <foreach collection="list" item="item" index="index" open="(" separator="," close=")">
            #{item.id}
        </foreach>
    </delete>
    <!-- 根据paramDto删除一批 -->
    <delete id="deleteByMap" parameterType="paramDto">
        delete a.* from mortals_xhx_metting_record as a
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
    </delete>
    <!-- 获取列表 -->
    <select id="getList" parameterType="paramDto" resultMap="MettingRecordEntity-Map">
        select <include refid="_columns"/>
        from mortals_xhx_metting_record as a
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
        <include refid="_orderCols_"/>
    </select>



    <!-- 获取 -->
    <select id="getListCount" parameterType="paramDto" resultType="int">
        select count(1)
        from mortals_xhx_metting_record as a
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
    </select>
    <!-- 条件映射 -->
    <sql id="_condition_">
        <if test="condition != null and !condition.isEmpty()">
            <!-- 条件映射-普通条件 -->
            <include refid="_condition_param_">
                <property name="_conditionParam_" value="condition"/>
                <property name="_conditionType_" value="and"/>
            </include>
            <!-- 条件映射-集合之间使用AND，集合中元素使用OR-(list[0].1 or list[0].2) and (list[1].3 or list[1].4) -->
            <if test="condition.containsKey('andConditionList') and !condition.andConditionList.isEmpty()">
                and
                <foreach collection="condition.andConditionList" open="(" close=")" index="index" item="andCondition" separator=" and ">
                    <trim prefixOverrides="or" prefix="(" suffix=")">
                        <include refid="_condition_param_">
                            <property name="_conditionParam_" value="andCondition"/>
                            <property name="_conditionType_" value="or"/>
                        </include>
                    </trim>
                </foreach>
            </if>
            <!-- 条件映射-集合之间使用OR，集合中元素使用AND-(list[0].1 and list[0].2) or (list[1].3 and list[1].4) -->
            <if test="condition.containsKey('orConditionList') and !condition.orConditionList.isEmpty()">
                and
                <foreach collection="condition.orConditionList" open="(" close=")" index="index" item="orCondition" separator=" or ">
                    <trim prefixOverrides="and" prefix="(" suffix=")">
                        <include refid="_condition_param_">
                            <property name="_conditionParam_" value="orCondition"/>
                            <property name="_conditionType_" value="and"/>
                        </include>
                    </trim>
                </foreach>
            </if>
        </if>
    </sql>
    <!-- 条件映射-代参数 -->
    <sql id="_condition_param_">
        <bind name="conditionParamRef" value="${_conditionParam_}"/>
        <if test="conditionParamRef.containsKey('id')">
            <if test="conditionParamRef.id != null">
                ${_conditionType_} a.id=#{${_conditionParam_}.id}
            </if>
        </if>
            <if test="conditionParamRef.containsKey('id')">
                <if test="conditionParamRef.id != null ">
                    ${_conditionType_} a.id = #{${_conditionParam_}.id}
                </if>
                <if test="conditionParamRef.id == null">
                    ${_conditionType_} a.id is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('idList') and conditionParamRef.idList.size() > 0">
                ${_conditionType_} a.id in
                <foreach collection="conditionParamRef.idList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('idNotList') and conditionParamRef.idNotList.size() > 0">
                ${_conditionType_} a.id not in
                <foreach collection="conditionParamRef.idNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('idStart') and conditionParamRef.idStart != null">
                ${_conditionType_} a.id <![CDATA[ >= ]]> #{${_conditionParam_}.idStart}
            </if>
            <if test="conditionParamRef.containsKey('idEnd') and conditionParamRef.idEnd != null">
                ${_conditionType_} a.id <![CDATA[ <= ]]> #{${_conditionParam_}.idEnd}
            </if>


            <if test="conditionParamRef.containsKey('meetName')">
                <if test="conditionParamRef.meetName != null and conditionParamRef.meetName != ''">
                    ${_conditionType_} a.meetName like #{${_conditionParam_}.meetName}
                </if>
                <if test="conditionParamRef.meetName == null">
                    ${_conditionType_} a.meetName is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('meetNameList') and conditionParamRef.meetNameList.size() > 0">
                ${_conditionType_} a.meetName in
                <foreach collection="conditionParamRef.meetNameList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('meetNameNotList') and conditionParamRef.meetNameNotList.size() > 0">
                ${_conditionType_} a.meetName not in
                <foreach collection="conditionParamRef.meetNameNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>

            <if test="conditionParamRef.containsKey('meetDate')">
                <if test="conditionParamRef.meetDate != null ">
                    ${_conditionType_} a.meetDate = #{${_conditionParam_}.meetDate}
                </if>
                <if test="conditionParamRef.meetDate == null">
                    ${_conditionType_} a.meetDate is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('meetDateStart') and conditionParamRef.meetDateStart != null and conditionParamRef.meetDateStart!=''">
                ${_conditionType_} a.meetDate <![CDATA[ >= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.meetDateStart},' 00:00:00'),19),'%Y-%m-%d %k:%i:%s')
            </if>
            <if test="conditionParamRef.containsKey('meetDateEnd') and conditionParamRef.meetDateEnd != null and conditionParamRef.meetDateEnd!=''">
                ${_conditionType_} a.meetDate <![CDATA[ <= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.meetDateEnd},' 23:59:59'),19),'%Y-%m-%d %k:%i:%s')
            </if>

            <if test="conditionParamRef.containsKey('meetTimeStart')">
                <if test="conditionParamRef.meetTimeStart != null ">
                    ${_conditionType_} a.meetTimeStart = #{${_conditionParam_}.meetTimeStart}
                </if>
                <if test="conditionParamRef.meetTimeStart == null">
                    ${_conditionType_} a.meetTimeStart is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('meetTimeStartStart') and conditionParamRef.meetTimeStartStart != null and conditionParamRef.meetTimeStartStart!=''">
                ${_conditionType_} a.meetTimeStart <![CDATA[ >= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.meetTimeStartStart},' 00:00:00'),19),'%Y-%m-%d %k:%i:%s')
            </if>
            <if test="conditionParamRef.containsKey('meetTimeStartEnd') and conditionParamRef.meetTimeStartEnd != null and conditionParamRef.meetTimeStartEnd!=''">
                ${_conditionType_} a.meetTimeStart <![CDATA[ <= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.meetTimeStartEnd},' 23:59:59'),19),'%Y-%m-%d %k:%i:%s')
            </if>

            <if test="conditionParamRef.containsKey('meetTimeEnd')">
                <if test="conditionParamRef.meetTimeEnd != null ">
                    ${_conditionType_} a.meetTimeEnd = #{${_conditionParam_}.meetTimeEnd}
                </if>
                <if test="conditionParamRef.meetTimeEnd == null">
                    ${_conditionType_} a.meetTimeEnd is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('meetTimeEndStart') and conditionParamRef.meetTimeEndStart != null and conditionParamRef.meetTimeEndStart!=''">
                ${_conditionType_} a.meetTimeEnd <![CDATA[ >= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.meetTimeEndStart},' 00:00:00'),19),'%Y-%m-%d %k:%i:%s')
            </if>
            <if test="conditionParamRef.containsKey('meetTimeEndEnd') and conditionParamRef.meetTimeEndEnd != null and conditionParamRef.meetTimeEndEnd!=''">
                ${_conditionType_} a.meetTimeEnd <![CDATA[ <= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.meetTimeEndEnd},' 23:59:59'),19),'%Y-%m-%d %k:%i:%s')
            </if>
            <if test="conditionParamRef.containsKey('roomId')">
                <if test="conditionParamRef.roomId != null ">
                    ${_conditionType_} a.roomId = #{${_conditionParam_}.roomId}
                </if>
                <if test="conditionParamRef.roomId == null">
                    ${_conditionType_} a.roomId is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('roomIdList') and conditionParamRef.roomIdList.size() > 0">
                ${_conditionType_} a.roomId in
                <foreach collection="conditionParamRef.roomIdList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('roomIdNotList') and conditionParamRef.roomIdNotList.size() > 0">
                ${_conditionType_} a.roomId not in
                <foreach collection="conditionParamRef.roomIdNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('roomIdStart') and conditionParamRef.roomIdStart != null">
                ${_conditionType_} a.roomId <![CDATA[ >= ]]> #{${_conditionParam_}.roomIdStart}
            </if>
            <if test="conditionParamRef.containsKey('roomIdEnd') and conditionParamRef.roomIdEnd != null">
                ${_conditionType_} a.roomId <![CDATA[ <= ]]> #{${_conditionParam_}.roomIdEnd}
            </if>


            <if test="conditionParamRef.containsKey('roomName')">
                <if test="conditionParamRef.roomName != null and conditionParamRef.roomName != ''">
                    ${_conditionType_} a.roomName like #{${_conditionParam_}.roomName}
                </if>
                <if test="conditionParamRef.roomName == null">
                    ${_conditionType_} a.roomName is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('roomNameList') and conditionParamRef.roomNameList.size() > 0">
                ${_conditionType_} a.roomName in
                <foreach collection="conditionParamRef.roomNameList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('roomNameNotList') and conditionParamRef.roomNameNotList.size() > 0">
                ${_conditionType_} a.roomName not in
                <foreach collection="conditionParamRef.roomNameNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>

            <if test="conditionParamRef.containsKey('meetDeptName')">
                <if test="conditionParamRef.meetDeptName != null and conditionParamRef.meetDeptName != ''">
                    ${_conditionType_} a.meetDeptName like #{${_conditionParam_}.meetDeptName}
                </if>
                <if test="conditionParamRef.meetDeptName == null">
                    ${_conditionType_} a.meetDeptName is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('meetDeptNameList') and conditionParamRef.meetDeptNameList.size() > 0">
                ${_conditionType_} a.meetDeptName in
                <foreach collection="conditionParamRef.meetDeptNameList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('meetDeptNameNotList') and conditionParamRef.meetDeptNameNotList.size() > 0">
                ${_conditionType_} a.meetDeptName not in
                <foreach collection="conditionParamRef.meetDeptNameNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('meetStatus')">
                <if test="conditionParamRef.meetStatus != null ">
                    ${_conditionType_} a.meetStatus = #{${_conditionParam_}.meetStatus}
                </if>
                <if test="conditionParamRef.meetStatus == null">
                    ${_conditionType_} a.meetStatus is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('meetStatusList') and conditionParamRef.meetStatusList.size() > 0">
                ${_conditionType_} a.meetStatus in
                <foreach collection="conditionParamRef.meetStatusList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('meetStatusNotList') and conditionParamRef.meetStatusNotList.size() > 0">
                ${_conditionType_} a.meetStatus not in
                <foreach collection="conditionParamRef.meetStatusNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('meetStatusStart') and conditionParamRef.meetStatusStart != null">
                ${_conditionType_} a.meetStatus <![CDATA[ >= ]]> #{${_conditionParam_}.meetStatusStart}
            </if>
            <if test="conditionParamRef.containsKey('meetStatusEnd') and conditionParamRef.meetStatusEnd != null">
                ${_conditionType_} a.meetStatus <![CDATA[ <= ]]> #{${_conditionParam_}.meetStatusEnd}
            </if>

            <if test="conditionParamRef.containsKey('finishMethod')">
                <if test="conditionParamRef.finishMethod != null ">
                    ${_conditionType_} a.finishMethod = #{${_conditionParam_}.finishMethod}
                </if>
                <if test="conditionParamRef.finishMethod == null">
                    ${_conditionType_} a.finishMethod is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('finishMethodList') and conditionParamRef.finishMethodList.size() > 0">
                ${_conditionType_} a.finishMethod in
                <foreach collection="conditionParamRef.finishMethodList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('finishMethodNotList') and conditionParamRef.finishMethodNotList.size() > 0">
                ${_conditionType_} a.finishMethod not in
                <foreach collection="conditionParamRef.finishMethodNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('finishMethodStart') and conditionParamRef.finishMethodStart != null">
                ${_conditionType_} a.finishMethod <![CDATA[ >= ]]> #{${_conditionParam_}.finishMethodStart}
            </if>
            <if test="conditionParamRef.containsKey('finishMethodEnd') and conditionParamRef.finishMethodEnd != null">
                ${_conditionType_} a.finishMethod <![CDATA[ <= ]]> #{${_conditionParam_}.finishMethodEnd}
            </if>


            <if test="conditionParamRef.containsKey('remark')">
                <if test="conditionParamRef.remark != null and conditionParamRef.remark != ''">
                    ${_conditionType_} a.remark like #{${_conditionParam_}.remark}
                </if>
                <if test="conditionParamRef.remark == null">
                    ${_conditionType_} a.remark is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('remarkList') and conditionParamRef.remarkList.size() > 0">
                ${_conditionType_} a.remark in
                <foreach collection="conditionParamRef.remarkList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('remarkNotList') and conditionParamRef.remarkNotList.size() > 0">
                ${_conditionType_} a.remark not in
                <foreach collection="conditionParamRef.remarkNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('createUserId')">
                <if test="conditionParamRef.createUserId != null ">
                    ${_conditionType_} a.createUserId = #{${_conditionParam_}.createUserId}
                </if>
                <if test="conditionParamRef.createUserId == null">
                    ${_conditionType_} a.createUserId is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('createUserIdList') and conditionParamRef.createUserIdList.size() > 0">
                ${_conditionType_} a.createUserId in
                <foreach collection="conditionParamRef.createUserIdList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('createUserIdNotList') and conditionParamRef.createUserIdNotList.size() > 0">
                ${_conditionType_} a.createUserId not in
                <foreach collection="conditionParamRef.createUserIdNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('createUserIdStart') and conditionParamRef.createUserIdStart != null">
                ${_conditionType_} a.createUserId <![CDATA[ >= ]]> #{${_conditionParam_}.createUserIdStart}
            </if>
            <if test="conditionParamRef.containsKey('createUserIdEnd') and conditionParamRef.createUserIdEnd != null">
                ${_conditionType_} a.createUserId <![CDATA[ <= ]]> #{${_conditionParam_}.createUserIdEnd}
            </if>


            <if test="conditionParamRef.containsKey('createTime')">
                <if test="conditionParamRef.createTime != null ">
                    ${_conditionType_} a.createTime = #{${_conditionParam_}.createTime}
                </if>
                <if test="conditionParamRef.createTime == null">
                    ${_conditionType_} a.createTime is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('createTimeStart') and conditionParamRef.createTimeStart != null and conditionParamRef.createTimeStart!=''">
                ${_conditionType_} a.createTime <![CDATA[ >= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.createTimeStart},' 00:00:00'),19),'%Y-%m-%d %k:%i:%s')
            </if>
            <if test="conditionParamRef.containsKey('createTimeEnd') and conditionParamRef.createTimeEnd != null and conditionParamRef.createTimeEnd!=''">
                ${_conditionType_} a.createTime <![CDATA[ <= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.createTimeEnd},' 23:59:59'),19),'%Y-%m-%d %k:%i:%s')
            </if>
            <if test="conditionParamRef.containsKey('updateUserId')">
                <if test="conditionParamRef.updateUserId != null ">
                    ${_conditionType_} a.updateUserId = #{${_conditionParam_}.updateUserId}
                </if>
                <if test="conditionParamRef.updateUserId == null">
                    ${_conditionType_} a.updateUserId is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('updateUserIdList') and conditionParamRef.updateUserIdList.size() > 0">
                ${_conditionType_} a.updateUserId in
                <foreach collection="conditionParamRef.updateUserIdList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('updateUserIdNotList') and conditionParamRef.updateUserIdNotList.size() > 0">
                ${_conditionType_} a.updateUserId not in
                <foreach collection="conditionParamRef.updateUserIdNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('updateUserIdStart') and conditionParamRef.updateUserIdStart != null">
                ${_conditionType_} a.updateUserId <![CDATA[ >= ]]> #{${_conditionParam_}.updateUserIdStart}
            </if>
            <if test="conditionParamRef.containsKey('updateUserIdEnd') and conditionParamRef.updateUserIdEnd != null">
                ${_conditionType_} a.updateUserId <![CDATA[ <= ]]> #{${_conditionParam_}.updateUserIdEnd}
            </if>


            <if test="conditionParamRef.containsKey('updateTime')">
                <if test="conditionParamRef.updateTime != null ">
                    ${_conditionType_} a.updateTime = #{${_conditionParam_}.updateTime}
                </if>
                <if test="conditionParamRef.updateTime == null">
                    ${_conditionType_} a.updateTime is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('updateTimeStart') and conditionParamRef.updateTimeStart != null and conditionParamRef.updateTimeStart!=''">
                ${_conditionType_} a.updateTime <![CDATA[ >= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.updateTimeStart},' 00:00:00'),19),'%Y-%m-%d %k:%i:%s')
            </if>
            <if test="conditionParamRef.containsKey('updateTimeEnd') and conditionParamRef.updateTimeEnd != null and conditionParamRef.updateTimeEnd!=''">
                ${_conditionType_} a.updateTime <![CDATA[ <= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.updateTimeEnd},' 23:59:59'),19),'%Y-%m-%d %k:%i:%s')
            </if>
    </sql>
    <sql id="_orderCols_">
        <if test="orderColList != null and !orderColList.isEmpty()">
            order by
            <trim suffixOverrides=","  suffix="">
                <foreach collection="orderColList" open="" close="" index="index" item="item" separator=",">
                     ${item.colName} ${item.sortKind}
                </foreach>
            </trim>
        </if>
        <if test="(orderColList == null or orderColList.isEmpty()) and orderCol != null and !orderCol.isEmpty()">
            order by
            <trim suffixOverrides=","  suffix="">
                    <if test="orderCol.containsKey('id')">
                        a.id
                        <if test='orderCol.id != null and "DESC".equalsIgnoreCase(orderCol.id)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('meetName')">
                        a.meetName
                        <if test='orderCol.meetName != null and "DESC".equalsIgnoreCase(orderCol.meetName)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('meetDate')">
                        a.meetDate
                        <if test='orderCol.meetDate != null and "DESC".equalsIgnoreCase(orderCol.meetDate)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('meetTimeStart')">
                        a.meetTimeStart
                        <if test='orderCol.meetTimeStart != null and "DESC".equalsIgnoreCase(orderCol.meetTimeStart)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('meetTimeEnd')">
                        a.meetTimeEnd
                        <if test='orderCol.meetTimeEnd != null and "DESC".equalsIgnoreCase(orderCol.meetTimeEnd)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('roomId')">
                        a.roomId
                        <if test='orderCol.roomId != null and "DESC".equalsIgnoreCase(orderCol.roomId)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('roomName')">
                        a.roomName
                        <if test='orderCol.roomName != null and "DESC".equalsIgnoreCase(orderCol.roomName)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('meetDeptName')">
                        a.meetDeptName
                        <if test='orderCol.meetDeptName != null and "DESC".equalsIgnoreCase(orderCol.meetDeptName)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('meetStatus')">
                        a.meetStatus
                        <if test='orderCol.meetStatus != null and "DESC".equalsIgnoreCase(orderCol.meetStatus)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('finishMethod')">
                        a.finishMethod
                        <if test='orderCol.finishMethod != null and "DESC".equalsIgnoreCase(orderCol.finishMethod)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('remark')">
                        a.remark
                        <if test='orderCol.remark != null and "DESC".equalsIgnoreCase(orderCol.remark)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('createUserId')">
                        a.createUserId
                        <if test='orderCol.createUserId != null and "DESC".equalsIgnoreCase(orderCol.createUserId)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('createTime')">
                        a.createTime
                        <if test='orderCol.createTime != null and "DESC".equalsIgnoreCase(orderCol.createTime)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('updateUserId')">
                        a.updateUserId
                        <if test='orderCol.updateUserId != null and "DESC".equalsIgnoreCase(orderCol.updateUserId)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('updateTime')">
                        a.updateTime
                        <if test='orderCol.updateTime != null and "DESC".equalsIgnoreCase(orderCol.updateTime)'>DESC</if>
                        ,
                    </if>
            </trim>
        </if>
    </sql>
    <sql id="_group_by_">
        <if test="groupList != null and !groupList.isEmpty()">
            GROUP BY
            <trim suffixOverrides=","  suffix="">
                <foreach collection="groupList" open="" close="" index="index" item="item" separator=",">
                    ${item}
                </foreach>
            </trim>
        </if>
    </sql>
</mapper>